testcov <- function(x, covmod, ...)
{
    n <- nrow(x)
    covmod <- covmod
    args <- list(...)
    if(length(args)) {
      pm <- pmatch(names(args), names(covmod), nomatch=0)
      if(any(pm == 0)) warning(paste("some of ... do not match"))
      covmod[pm] <- unlist(args)
    }
    defn <- c("function(x){covmod <-",deparse(covmod),"covmod(x)}")
    krcov <- eval(parse(text=defn))
    d <- c(0, dist(x))
    eps <- 1e-3 * max(d)
    z <- .Call("Call_cov", d, eps, functionBody(krcov), new.frame())
    cov <- matrix(0, n, n)
    cov[lower.tri(cov)] <- z[-1]
    cov <- cov + t(cov)
    diag(cov) <- z[1]
    cov
}
